Loading...
Searching...
No Matches
wayland::server::xdg_wm_base_t Class Reference

create desktop-style surfaces More...

`#include <wayland-server-protocol-extra.hpp>`

Inherits wayland::server::resource_t.

## Public Member Functions

std::function< void()> & | on_destroy ()
| destroy xdg_wm_base
std::function< void(xdg_positioner_t)> & | on_create_positioner ()
| create a positioner object
std::function< void(xdg_surface_t, surface_t)> & | on_get_xdg_surface ()
| create a shell surface from a surface
std::function< void(uint32_t)> & | on_pong ()
| respond to a ping event
void | ping (uint32_t serial, bool post=true)
| check if the client is alive
void | post_role (std::string const &msg)
| Post error: given wl_surface has another role.
void | post_defunct_surfaces (std::string const &msg)
| Post error: xdg_wm_base was destroyed before children.
void | post_not_the_topmost_popup (std::string const &msg)
| Post error: the client tried to map or destroy a non-topmost popup.
void | post_invalid_popup_parent (std::string const &msg)
| Post error: the client specified an invalid popup parent surface.
void | post_invalid_surface_state (std::string const &msg)
| Post error: the client provided an invalid surface state.
void | post_invalid_positioner (std::string const &msg)
| Post error: the client provided an invalid positioner.
bool | proxy_has_object () const
| Check whether this wrapper actually wraps an object.
void | post_no_memory () const
uint32_t | get_id () const
client_t | get_client () const
unsigned int | get_version () const
std::string | get_class ()

## Static Public Attributes

static constexpr std::uint32_t | ping_since_version = 1
| Minimum protocol version required for the ping function.

## Detailed Description

create desktop-style surfaces

The xdg_wm_base interface is exposed as a global object enabling clients to turn their wl_surfaces into windows in a desktop environment. It defines the basic functionality needed for clients and the compositor to create windows that can be dragged, resized, maximized, etc, as well as creating transient windows such as popup menus.

Definition at line 613 of file wayland-server-protocol-extra.hpp.

## Member Function Documentation

## get_class()

std::string wayland::server::resource_t::get_class | ( |  | ) |

inherited

Retrieve the interface name (class) of a resource object.

Returns
  Interface name of the resource object.

## get_client()

client_t wayland::server::resource_t::get_client | ( |  | ) | const

inherited

Get the associated client

Returns
  the client that owns the resource.

## get_id()

uint32_t wayland::server::resource_t::get_id | ( |  | ) | const

inherited

Get the internal ID of the resource

Returns
  the internal ID of the resource

## get_version()

unsigned int wayland::server::resource_t::get_version | ( |  | ) | const

inherited

Get interface version

Returns
  Interface version this resource has been constructed with.

## on_create_positioner()

std::function< void(xdg_positioner_t)> & xdg_wm_base_t::on_create_positioner | ( |  | ) |

create a positioner object

Parameters

  id |

Create a positioner object. A positioner object is used to position surfaces relative to some parent surface. See the interface description and xdg_surface.get_popup for details.

Definition at line 930 of file wayland-server-protocol-extra.cpp.

## on_destroy()

std::function< void()> & xdg_wm_base_t::on_destroy | ( |  | ) |

destroy xdg_wm_base

Destroy this xdg_wm_base object.

Destroying a bound xdg_wm_base object while there are surfaces still alive created by this xdg_wm_base object instance is illegal and will result in a protocol error.

Definition at line 924 of file wayland-server-protocol-extra.cpp.

## on_get_xdg_surface()

std::function< void(xdg_surface_t, surface_t)> & xdg_wm_base_t::on_get_xdg_surface | ( |  | ) |

create a shell surface from a surface

Parameters

  id |
  surface |

This creates an xdg_surface for the given surface. While xdg_surface itself is not a role, the corresponding surface may only be assigned a role extending xdg_surface, such as xdg_toplevel or xdg_popup. It is illegal to create an xdg_surface for a wl_surface which already has an assigned role and this will result in a protocol error.

This creates an xdg_surface for the given surface. An xdg_surface is used as basis to define a role to a given surface, such as xdg_toplevel or xdg_popup. It also manages functionality shared between xdg_surface based surface roles.

See the documentation of xdg_surface for more details about what an xdg_surface is and how it is used.

Definition at line 936 of file wayland-server-protocol-extra.cpp.

## on_pong()

std::function< void(uint32_t)> & xdg_wm_base_t::on_pong | ( |  | ) |

respond to a ping event

Parameters

  serial | serial of the ping event

A client must respond to a ping event with a pong request or the client may be deemed unresponsive. See xdg_wm_base.ping.

Definition at line 942 of file wayland-server-protocol-extra.cpp.

## ping()

void xdg_wm_base_t::ping | ( | uint32_t | serial,
|  | bool | post = `true`
| ) |  |

check if the client is alive

Parameters

  serial | pass this to the pong request

The ping event asks the client if it's still alive. Pass the serial specified in the event back to the compositor by sending a "pong" request back with the specified serial. See xdg_wm_base.pong.

Compositors can use this to determine if the client is still alive. It's unspecified what will happen if the client doesn't respond to the ping request, or in what timeframe. Clients should try to respond in a reasonable amount of time.

A compositor is free to ping in any way it wants, but a client must always respond to any xdg_wm_base object it created.

Definition at line 948 of file wayland-server-protocol-extra.cpp.

## post_defunct_surfaces()

void xdg_wm_base_t::post_defunct_surfaces | ( | std::string const & | msg | ) |

Post error: xdg_wm_base was destroyed before children.

Definition at line 958 of file wayland-server-protocol-extra.cpp.

## post_invalid_popup_parent()

void xdg_wm_base_t::post_invalid_popup_parent | ( | std::string const & | msg | ) |

Post error: the client specified an invalid popup parent surface.

Definition at line 968 of file wayland-server-protocol-extra.cpp.

## post_invalid_positioner()

void xdg_wm_base_t::post_invalid_positioner | ( | std::string const & | msg | ) |

Post error: the client provided an invalid positioner.

Definition at line 978 of file wayland-server-protocol-extra.cpp.

## post_invalid_surface_state()

void xdg_wm_base_t::post_invalid_surface_state | ( | std::string const & | msg | ) |

Post error: the client provided an invalid surface state.

Definition at line 973 of file wayland-server-protocol-extra.cpp.

## post_no_memory()

void wayland::server::resource_t::post_no_memory | ( |  | ) | const

inherited

Post "not enough memory" error to the client

If the compositor has not enough memory to fulfill a certail request of the client, this function can be called to notify the client of this circumstance.

## post_not_the_topmost_popup()

void xdg_wm_base_t::post_not_the_topmost_popup | ( | std::string const & | msg | ) |

Post error: the client tried to map or destroy a non-topmost popup.

Definition at line 963 of file wayland-server-protocol-extra.cpp.

## post_role()

void xdg_wm_base_t::post_role | ( | std::string const & | msg | ) |

Post error: given wl_surface has another role.

Definition at line 953 of file wayland-server-protocol-extra.cpp.

## proxy_has_object()

bool wayland::server::resource_t::proxy_has_object | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## Member Data Documentation

## ping_since_version

constexpr std::uint32_t wayland::server::xdg_wm_base_t::ping_since_version = 1

static constexpr

Minimum protocol version required for the ping function.

Definition at line 713 of file wayland-server-protocol-extra.hpp.

The documentation for this class was generated from the following files:

- obj-x86_64-linux-gnu/wayland-server-protocol-extra.hpp
- obj-x86_64-linux-gnu/wayland-server-protocol-extra.cpp